﻿

using System.IO;
using Infragistics.Olap.FlatData;
using Infragistics.Olap.Excel;
using System.Windows;
using Infragistics.Olap;
using System;
namespace SortingXamGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
      
        public MainWindow()
        {
            InitializeComponent();                    
            LoadExcelFileData();
        }

        private void LoadExcelFileData()
        {
            Stream stream = new FileStream(@"C:\Test.xls", FileMode.Open);           
            FlatDataSource dataSource = CreateDataSource(stream);
            this.PivotGrid.DataSource = dataSource;
            this.dataSelector.DataSource = dataSource;
            stream.Close();
        }

        private FlatDataSource CreateDataSource(Stream fileStream)
        {
            FlatDataSource flatDataSource = new FlatDataSource();
            ExcelDataConnectionSettings excelDataConnectionSettings =
                new ExcelDataConnectionSettings
                {
                    FileStream = fileStream,
                    GeneratedTypeName = "ExcelData",
                    WorksheetName = "Sheet1"
                };

            string excelStringFormat =
                        "\"$\"#,##0.00_);[Red]\\(\"$\"#,##0.00\\)";
            string systemValueFormat =
                       "{0:C3}";
            ExcelDataConnectionSettings.AddExcelCellFormatMapping(
                          excelStringFormat, systemValueFormat);


            flatDataSource.Cube =
                  DataSourceBase.GenerateInitialCube("ExcelData");

            flatDataSource.Rows =
               DataSourceBase.GenerateInitialItems("[CATEGORYINFO].[CATEGORYINFO],[LEVELINFO].[LEVELINFO],[SOURCEINFO].[SOURCEINFO]");

            flatDataSource.Measures =
               DataSourceBase.GenerateInitialItems("TOTAL_COUNT");
           
            flatDataSource.ConnectionSettings =
                            excelDataConnectionSettings;


            flatDataSource.CubesSettings.Add(
                new CubeMetadata
                {
                    DataTypeFullName = "ExcelData",
                    DisplayName = "Sheet1 Data"
                });

            HierarchyDescriptor stringDataDescriptor = new HierarchyDescriptor
            {
                AppliesToPropertiesOfType = typeof(string)
            };      
           
            stringDataDescriptor.AddLevel<string>(s => s, "SOURCEINFO");            

           flatDataSource.HierarchyDescriptors.Add(stringDataDescriptor);
        

            return flatDataSource;
        }


    }
}
